program DCG;

uses
  Forms,
  Instance in 'Instance.pas',
  Project in 'Project.pas' {ProjectForm},
  DCGData in 'DCGData.pas' {ApplicationData: TDataModule},
  LexerGenerator in 'LexerGenerator.pas',
  Main in 'Main.pas' {MainForm},
  WindowList in 'WindowList.pas' {WindowListForm},
  ParserGenerator in 'ParserGenerator.pas',
  CompileDlg in 'CompileDlg.pas' {CompileDialog},
  ProjectOptionsDlg in 'ProjectOptionsDlg.pas' {ProjectOptionsDialog},
  DCGTools in 'DCGTools.pas',
  EnvironmentOptionsDlg in 'EnvironmentOptionsDlg.pas' {EnvironmentOptionsDialog},
  DCGStrings in 'DCGStrings.pas',
  DockForm in 'DockForm.pas' {DockableForm},
  Find in 'Find.pas' {SyntaxFindDialog},
  MessageWindow in 'MessageWindow.pas' {MessageForm},
  ConjoinHost in 'ConjoinHost.pas' {ConjoinDockHost};

{$R *.RES}

begin
  if not CheckForOtherInstance then
  begin
    // Be careful: because the data module creation initiates loading of the
    //             preferences the main form as well as the window list form must
    //             be created before the data module!
    Application.Initialize;
    Application.Title := '';
    Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TWindowListForm, WindowListForm);
  Application.CreateForm(TProjectOptionsDialog, ProjectOptionsDialog);
  Application.CreateForm(TEnvironmentOptionsDialog, EnvironmentOptionsDialog);
  Application.CreateForm(TCompileDialog, CompileDialog);
  Application.CreateForm(TApplicationData, ApplicationData);
  Application.CreateForm(TSyntaxFindDialog, SyntaxFindDialog);
  Application.CreateForm(TConjoinDockHost, ConjoinDockHost);
  Application.Run;
  end;
end.

