unit DCGStrings;

// 05-DEC-99 ml: version string
// 03-JUL-99 ml: implementation so far
//----------------------------------------------------------------------------------------------------------------------

interface

resourcestring

  SVersion = 'Delphi Compiler Generator 1.2';
  
  // syntax errors
  SSyntaxError = '[Syntax Error]';
  SUnmatchedLeftBrace = 'Unmatched %{';
  SUnexpectedEOI = 'Unexpected end of input';
  SOpenCommentAtEOI = 'Open comment at end of input';
  SMissingStringTerminator = 'Missing string terminator';
  SRightCurlyExpected = '%} expected';
  SRightBraceExpected = '} expected';
  SRightAngleExpected = '> expected';
  SIdentifierExpected = 'Identifier expected';
  SErrorInDefinition = 'incorrect definition';
  SErrorInRule = 'incorrect rule';
  SMacroEndExpected = ' expected';

  // semantic errors
  SSemanticError = '[Semantic Error]';
  SSymbolAlreadyDefined = 'Symbol already defined';
  SSymbolUndefined = 'Undefined symbol';
  SInvalidCharacterNumber = 'Invalid character number';
  SEmptyGrammar = 'Empty grammar?';
  SNonterminalExpected = 'nonterminal expected';
  SLiteralExpected = 'Literal expected';
  SDoubleTokenDef = 'Literal already defined';
  SUnknownIdentifier = 'Unknown identifier';
  STypeError = 'Type error';
  SRangeError = 'Range error';

  // other errors and messages
  SFatalError = '[Fatal Error] ';
  SError = '[Error] ';
  SWarning = '[Warning] ';
  SHint = '[Hint] ';
  SLog = '[Log] ';
  SSourceMissing  = 'Source file does not exist';
  STemplateMissing  = 'Template file does not exist';
  SCannotOpenFile = 'Cannot open file';
  SWriteError = 'Write error';
  SDCCNotFound = 'DCC32 not found';

  SMacroStackOverflow = 'Macro stack overflow';
  SSymTableOverflow = 'Symbol table overflow';

  // common strings
  SProjectFilter = 'Delphi compiler generator project (*.dcg)|*.dcg';
  SDelphiProjectFilter = 'Delphi project (*.dpr)|*.dpr';
  SUnitFilter = 'Delphi source file (*.pas)|*.pas';
  SLexerFilter = 'Lexical description (*.l)|*.l';
  SParserFilter = 'Parser description (*.y)|*.y';
  SCodeTemplateFilter = 'DCG code template (*.cod)|*.cod';
  SAnyFileFilter = 'Any file (*.*)|*.*';
  SExeFilter = 'Executables (*.exe)|*.exe';

  SMainCaption = '%s (%s)';
  SProjectPropertiesTitel = 'Properties for project %s:';
  SOpenTitel = 'Open';
  SSaveTitel = 'Save';
  SSaveAsTitel = 'Save %s as';

  SDelphiPathMacro = '$(DELPHI)';
  SDCGRegistryKey = 'Software\Delphi Compiler Generator';
  SBrowseFolder = 'Select directory where your Delphi installation is located in.';
  SUnregister = 'Note: Removing all DCG registry entries discards also all options'#13#10 +
                'and settings you might have changed!'#13#10#13#10 +
                'Do you really want to continue?';
  SFileDateTime = 'Module %s''s time/date changed. Reload?';
  SLexerWarning = 'Lexer description file is empty or not available.';
  SLexerTemplateWarning = 'Lexer template file is empty or not available.';
  SParserWarning = 'Parser description file is empty or not available.';
  SParserTemplateWarning = 'Parser template file is empty or not available.';

implementation
end.
