unit Main;

// 13-NOV-99 ml: structural rework
// 13-NOV-99 ml: implementation so far
//----------------------------------------------------------------------------------------------------------------------
// This unit contains the main form for the Delphi Compiler Generator (DCG) and provides
// access to all commands. It accepts dropped files to open either as new project or as file
// in the currently active editor window (depending on the file extension).

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ToolWin, ComCtrls, ImgList, ActnList, Project,
  StdActns, DCGData, SyntaxEditor;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileItem: TMenuItem;
    ExitItem: TMenuItem;
    MainActionList: TActionList;
    AppCloseAction: TAction;
    NewProjectAction: TAction;
    CloseAction: TAction;
    OpenAction: TAction;
    WindowItem: TMenuItem;
    WindowListItem: TMenuItem;
    WindowListAction: TAction;
    NeuesProjektItem: TMenuItem;
    ProjectOpenItem: TMenuItem;
    ProjectSaveItem: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    ProjectCloseItem: TMenuItem;
    SaveProjectAsAction: TAction;
    ProjectSaveAsItem: TMenuItem;
    ToolsItem: TMenuItem;
    ControlBar: TControlBar;
    MiscToolBar: TToolBar;
    WindowListButton: TToolButton;
    FileToolBar: TToolBar;
    NewButton: TToolButton;
    OpenButton: TToolButton;
    SaveButton: TToolButton;
    CloseButton: TToolButton;
    MenuImageList: TImageList;
    MRUPopup: TPopupMenu;
    EditCopyAction: TEditCopy;
    EditCutAction: TEditCut;
    EditPasteAction: TEditPaste;
    EditSelectAllAction: TAction;
    EditItem: TMenuItem;
    UndoItem: TMenuItem;
    RedoItem: TMenuItem;
    N1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    SelectAllItem: TMenuItem;
    EditUndoAction: TAction;
    EditRedoAction: TAction;
    SaveAllAction: TAction;
    SaveProjectAsItem: TMenuItem;
    SaveAsAction: TAction;
    SaveAction: TAction;
    SaveAllItem: TMenuItem;
    GenerateAction: TAction;
    ProjectItem: TMenuItem;
    GenerateItem: TMenuItem;
    RunAction: TAction;
    PropertiesAction: TAction;
    N5: TMenuItem;
    PropertiiesIem: TMenuItem;
    ControlCharButton: TToolButton;
    EditControlCharAction: TAction;
    N6: TMenuItem;
    ControlCharsItem: TMenuItem;
    ToolButton1: TToolButton;
    EditDeleteAction: TAction;
    DeleteItem: TMenuItem;
    EnvironmentItem: TMenuItem;
    ToolButton11: TToolButton;
    MenuToolBar: TToolBar;
    ToolButton10: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    EditToolBar: TToolBar;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolBarPopup: TPopupMenu;
    Showmenu1: TMenuItem;
    Showfiletoolbar1: TMenuItem;
    Showedittoolbar1: TMenuItem;
    Showcontroltoolbar1: TMenuItem;
    ToolButton2: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    EditFindAction: TAction;
    EditReplaceAction: TAction;
    EditFindAgainAction: TAction;
    SearchToolBar: TToolBar;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    ToolButton23: TToolButton;
    SearchItem: TMenuItem;
    FindItem: TMenuItem;
    ReplaceItem: TMenuItem;
    SearchAgainItem: TMenuItem;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton20: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure AppCloseActionExecute(Sender: TObject);
    procedure NewProjectActionExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CloseActionExecute(Sender: TObject);
    procedure OpenActionExecute(Sender: TObject);
    procedure WindowListActionExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SaveActionExecute(Sender: TObject);
    procedure SaveProjectAsActionExecute(Sender: TObject);
    procedure RegisterItemClick(Sender: TObject);
    procedure ControlBarResize(Sender: TObject);
    procedure MRUPopupPopup(Sender: TObject);
    procedure EditSelectAllActionExecute(Sender: TObject);
    procedure EditPasteActionExecute(Sender: TObject);
    procedure EditCutActionExecute(Sender: TObject);
    procedure EditCopyActionExecute(Sender: TObject);
    procedure SaveAsActionExecute(Sender: TObject);
    procedure GenerateActionExecute(Sender: TObject);
    procedure PropertiesActionExecute(Sender: TObject);
    procedure EditUndoActionExecute(Sender: TObject);
    procedure EditRedoActionExecute(Sender: TObject);
    procedure EditControlCharActionExecute(Sender: TObject);
    procedure SaveAllActionExecute(Sender: TObject);
    procedure EnvironmentItemClick(Sender: TObject);
    procedure ToolbarMenuItemClick(Sender: TObject);
    procedure EditFindReplaceActionExecute(Sender: TObject);
    procedure EditFindAgainActionExecute(Sender: TObject);
  private
    FActiveProject: TBaseProjectForm;
    FLastProjects: TStringList;
    FLastSearchOptions: TSearchOptions;
    procedure MRUClick(Sender: TObject);
    procedure OnHint(Sender: TObject);
    procedure OnMinimize(Sender: TObject);
    procedure OnRestore(Sender: TObject);
    procedure SetActiveProject(const Value: TBaseProjectForm);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure UpdateShortCuts;
    procedure CheckProjectFiles(Sender: TObject);
  protected
    function WindowHook(var Message: TMessage): Boolean;
    procedure UpdateActions; override;
  public
    Projects: TList;

    function AddProjectFile(const Name: String; ReadOnly: Boolean = False): TBaseProjectForm;
    procedure AddProjectFiles(const List : TStrings; ReadOnly: Boolean = False);
    procedure AddToMRUList(const Name: String);
    procedure NotifyProjects;
    procedure RemoveFromMRUList(const Name: String);
    procedure ReadPreferences;
    procedure WritePreferences;
    procedure ShowEnvironmentSettings(EditorOnly: Boolean);
    procedure UpdateCaption(const FileName: String);

    property ActiveProject: TBaseProjectForm read FActiveProject write SetActiveProject;
  end;

function VisibleDockClientCount(Control: TWinControl): Integer;

var
  MainForm: TMainForm;

//----------------------------------------------------------------------------------------------------------------------

implementation

uses
  Registry, WindowList, Instance, ShellAPI, DCGStrings, DCGTools,
  EnvironmentOptionsDlg, ProjectOptionsDlg, Clipbrd, EditorKeyCommands,
  Find;

{$R *.DFM}
{$R Res\Other.res}

const
  TrayIconMessage = 'DCGTrayIcon';

var
  TrayIconMessageID: Cardinal;

//----------------- helper functions -----------------------------------------------------------------------------------

function VisibleDockClientCount(Control: TWinControl): Integer;

var
  I: Integer;

begin
  Result := 0;
  for I := 0 to Control.DockClientCount - 1 do
    if Control.DockClients[I].Visible then Inc(Result);
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormCreate(Sender: TObject);

begin
  Left := 0;
  Top := 0;
  Projects := TList.Create;
  FLastProjects := TStringList.Create;
  Application.OnHint := OnHint;
  UpdateCaption('');
  Application.HookMainWindow(WindowHook);
  DragAcceptFiles(Handle, True);
  MenuToolBar.Font.Handle := GetStockObject(DEFAULT_GUI_FONT);

  TrayIconMessageID := RegisterWindowMessage(TrayIconMessage);
  Application.OnMinimize := OnMinimize;
  Application.OnRestore := OnRestore;
  Application.OnActivate := CheckProjectFiles;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AppCloseActionExecute(Sender: TObject);

begin
  Close;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.NewProjectActionExecute(Sender: TObject);

var
  NewProject: TProjectForm;

begin
  NewProject := TProjectForm.CreateFromFile(Self, '', True);
  Projects.Add(NewProject);
  WindowListForm.AddWindow(NewProject);
  ActiveProject := NewProject;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormDestroy(Sender: TObject);

begin
  if IsIconic(Application.Handle) then OnRestore(nil);
  Application.UnHookMainWindow(WindowHook);
  Projects.Free;
  FLastProjects.Free;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.UpdateCaption(const FileName: String);

begin
  if FileName <> '' then Caption := Format(SMainCaption, [SVersion, FileName])
                    else Caption := Format(SMainCaption, [SVersion, 'no project']);
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SetActiveProject(const Value: TBaseProjectForm);

begin
  if FActiveProject <> Value then
  begin
    FActiveProject := Value;
    if (FActiveProject = nil) and
       (Projects.Count > 0) then FActiveProject := Projects[0];

    if assigned(FActiveProject) then
    begin
      if FActiveProject.CanShow then WindowListForm.ActivateWindow(FActiveProject);
      CloseAction.enabled := True;
      GenerateAction.enabled := True;
      PropertiesAction.enabled := True;
      if FActiveProject.NeedSave then SaveAction.enabled := True
                                 else SaveAction.enabled := False;
      UpdateCaption(PureName(FActiveProject.WorkingFile));
    end
    else UpdateCaption('');
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.CloseActionExecute(Sender: TObject);

var
  LastID: Integer;
  CanClose: Boolean;

begin
  CanClose := False;
  if assigned(FActiveProject) then FActiveProject.OnCloseQuery(FActiveProject, CanClose);
  if CanClose then
  begin
    WindowListForm.RemoveWindow(FActiveProject);
    if not FActiveProject.NewProject then AddToMRUList(FActiveProject.WorkingFile);
    FActiveProject.Free;
    LastID := Projects.IndexOf(FActiveProject);
    if LastID > -1 then
    begin
      Projects.Delete(LastID);
      FActiveProject := nil;
      if Projects.Count = 0 then
      begin
        CloseAction.enabled := False;
        SaveProjectAsAction.enabled := False;
        SaveAction.enabled := False;
        GenerateAction.enabled := False;
        PropertiesAction.enabled := False;
        UpdateCaption('');
      end
      else
        if LastID > 0 then ActiveProject := Projects[LastID - 1]
                      else ActiveProject := Projects[Projects.Count - 1];
    end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.OpenActionExecute(Sender: TObject);

begin
  with ApplicationData.OpenDialog do
  begin
    DefaultExt := '*.dcg';
    if assigned(FActiveProject) then FileName := FActiveProject.WorkingFile;
    Filter := SProjectFilter + '|' +
              SDelphiProjectFilter + '|' +
              SUnitFilter + '|' +
              SLexerFilter + '|' +
              SCodeTemplateFilter + '|' +
              SParserFilter + '|' +
              SAnyFileFilter;
    Options := [ofAllowMultiSelect, ofEnableSizing];
    Title := SOpenTitel;

    if Execute then AddProjectFiles(Files, ofReadOnly in Options);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.WindowListActionExecute(Sender: TObject);

begin
  WindowListAction.Checked := not WindowListAction.Checked;
  with WindowListForm do
    if WindowListAction.Checked then
    begin
      Show;
      BringToFront;
    end
    else Hide;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);

var
  I: Integer;

begin
  for I := 0 to Projects.Count - 1 do
  begin
    CanClose := False;
    TProjectForm(Projects[I]).OnCloseQuery(WindowListForm.WindowListBox.Items.Objects[I], CanClose);
    if not CanClose then Break;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.OnHint(Sender: TObject);

begin
  if assigned(FActiveProject) then FActiveProject.SetStatus(GetLongHint(Application.Hint));
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SaveActionExecute(Sender: TObject);

begin
  if assigned(FActiveProject) then
  begin
    FActiveProject.Save;
    FActiveProject.SaveProject;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SaveProjectAsActionExecute(Sender: TObject);

begin
  if assigned(FActiveProject) then FActiveProject.SaveProjectAs;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.RegisterItemClick(Sender: TObject);

var
  Reg: TRegistry;

begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;
    Reg.OpenKey('\.dcg', True);
    Reg.WriteString('', 'DCGProject');
    Reg.OpenKey('\DCGProject', True);
    Reg.WriteString('', 'Delphi Compiler Generator Project');
    Reg.OpenKey('\DCGProject\DefaultIcon', True);
    Reg.WriteString('', Application.ExeName + ', 1');
    Reg.OpenKey('\DCGProject\Shell\open\command', True);
    Reg.WriteString('', Application.ExeName + ' "%1"');
    ShowMessage('successfully registered');
  finally
    Reg.Free;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

function TMainForm.WindowHook(var Message: TMessage): Boolean;

// watch other instances of this application

var
  List: TStringList;

begin
  if Message.Msg = WM_OTHERINSTANCE then
  begin
    List := TStringList.Create;
    List.Duplicates := dupIgnore;

    GetInstanceParams(List);
    // element 0 is the executable itself
    List.Delete(0);
    AddProjectFiles(List);
    List.Free;
    Message.Result := 0;
    Result := True;
  end
  else
    if Message.Msg = TrayIconMessageID then
    begin
      case Message.lParamLo of
        WM_LBUTTONDOWN, 
        WM_RBUTTONDOWN, 
        WM_LBUTTONDBLCLK, 
        WM_RBUTTONDBLCLK:
          begin
            Show;
            Application.Restore;
            Application.BringToFront;
            Result := True;
          end;
      else
        Result := False;
      end
    end
    else Result := False;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);

// the common game here if a file has been dropped on the application

var
  Buffer: array[0..MAX_PATH] of Char;
  Count,
  I: Integer;
  List: TStringList;

begin
  Count := DragQueryFile(Msg.Drop, DWORD(-1), nil, 0);
  List := TStringList.Create;
  for I := 0 to Count - 1 do
  begin
    DragQueryFile(Msg.Drop, I, Buffer, MAX_PATH);
    List.Add(Buffer);
  end;
  AddProjectFiles(List);
  List.Free;
  DragFinish(Msg.Drop);
  Msg.Result := 0;
end;

//----------------------------------------------------------------------------------------------------------------------

function TMainForm.AddProjectFile(const Name: String; ReadOnly: Boolean = False): TBaseProjectForm;

var
  Ext: String;

begin
  if not WindowListForm.ProjectIsOpen(Name, Result) then
  begin
    Ext := ExtractFileExt(Name);
    if CompareText(Ext, '.dcg') = 0 then 
    begin
      RemoveFromMRUList(Name);
      if FileExists(Name) then
      begin
        Result := TProjectForm.CreateFromFile(Self, Name, True);
        SaveProjectAsAction.enabled := True;
        Projects.Add(Result);
        WindowListForm.AddWindow(Result);
        ActiveProject := Result;
      end;
    end
    else
    begin
      // if the given file is not a valid project file then just open it in the
      // current project as simple text file
      if FActiveProject = nil then NewProjectAction.Execute;
      TProjectForm(FActiveProject).AddEdit(Name, True, ReadOnly);
      // show that we have opened a simple text file
      Result := nil;
    end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AddProjectFiles(const List: TStrings; ReadOnly: Boolean = False);

var
  I: Integer;
  NewForm: TBaseProjectForm;

begin
  Screen.Cursor := crHourGlass;
  try
    NewForm := nil;
    for I := 0 to List.Count - 1 do NewForm := AddProjectFile(List[I], ReadOnly);

    if assigned(NewForm) then ActiveProject := NewForm;
  finally
    Screen.Cursor := crDefault;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ControlBarResize(Sender: TObject);

begin
  ClientHeight := ControlBar.Height;
  Constraints.MinHeight := ControlBar.Height + Height - ClientHeight;
  Constraints.MaxHeight := ControlBar.Height + Height - ClientHeight;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.OnMinimize(Sender: TObject);

var
  TrayIconData: TNotifyIconData;

begin
  if GlobalSettings.MinimizeToTray then
    with TrayIconData do
    begin
      ShowWindow(Application.Handle, SW_HIDE);
      cbSize := SizeOf(TNotifyIconData);
      Wnd := Application.Handle;
      uID := 1;
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
      uCallbackMessage := TrayIconMessageID;
      hIcon := Application.Icon.Handle;
      szTip := 'Delphi Compiler Generator';
      Shell_NotifyIcon(NIM_ADD, @TrayIconData);
    end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.OnRestore(Sender: TObject);

var
  TrayIconData: TNotifyIconData;

begin
  if GlobalSettings.MinimizeToTray then
    with TrayIconData do
    begin
      cbSize := SizeOf(TNotifyIconData);
      Wnd := Application.Handle;
      uID := 1;
      Shell_NotifyIcon(NIM_DELETE, @TrayIconData);
    end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.MRUPopupPopup(Sender: TObject);

var
  I: Integer;
  Hot: Integer;
  Item: TMenuItem;

begin
  for I := MRUPopup.Items.Count - 1 downto 0 do MRUPopup.Items.Delete(I);
  Hot := $30;
  for I := 0 to FLastProjects.Count - 1 do
  begin
    Item := TMenuItem.Create(MRUPopup);
    Item.Caption := '&' + Chr(Hot) + ' ' + FLastProjects[I];
    Item.OnClick := MRUClick;
    MRUPopup.Items.Add(Item);
    Inc(Hot);
    if (Hot > Ord('9')) and (Hot < Ord('A')) then Inc(Hot, 7);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AddToMRUList(const Name: String);

var
  I: Integer;

begin
  if CompareText('.dcg', ExtractFileExt(Name)) = 0 then
  begin
    I := FLastProjects.IndexOf(Name);
    if I > -1 then FLastProjects.Delete(I);
    FLastProjects.Insert(0, Name);
    while FLastProjects.Count > 10 do FLastProjects.Delete(FLastProjects.Count - 1);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.RemoveFromMRUList(const Name: String);

var
  I: Integer;

begin
  if CompareText('.dcg', ExtractFileExt(Name)) = 0 then
  begin
    I := FLastProjects.IndexOf(Name);
    if I > -1 then FLastProjects.Delete(I);       
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.MRUClick(Sender: TObject);

var
  FileName: String;

begin
  FileName := TMenuItem(Sender).Caption;
  Delete(FileName, 1, 3);
  AddProjectFile(FileName);
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ReadPreferences;

var
  List: TStringList;
  Key,
  EditorKey: HKEY;
  Size,
  Value,
  ValueType: DWORD;
  Placement: TWindowPlacement;
  Buffer: Pointer;

begin
  if RegOpenKey(HKEY_CURRENT_USER, 'Software\Delphi Compiler Generator', Key) = ERROR_SUCCESS then
  try
    // load editor settings
    if RegOpenKey(Key, 'Editor', EditorKey) = ERROR_SUCCESS then
      with GlobalSettings do
      try
        LoadKeystrokesFromRegistry(EditorKey, EditorCommands);
        LoadHighlightersFromRegistry(EditorKey);
        if (RegQueryValueEx(EditorKey, 'Edit Options', nil, nil, nil, @Size) = ERROR_SUCCESS) and
           (Size > 0) then
        begin
          GetMem(Buffer, Size);
          RegQueryValueEx(EditorKey, 'Edit Options', nil, nil, Buffer, @Size);
          EditOptions := TSyntaxEditOptions(Buffer^);
          FreeMem(Buffer);
        end;
        Size := 4;
        if RegQueryValueEx(EditorKey, 'Block Indent', nil, nil, @Value, @Size) = ERROR_SUCCESS then
          BlockIndent := Value;
        Size := 4;
        if RegQueryValueEx(EditorKey, 'Tab Size', nil, nil, @Value, @Size) = ERROR_SUCCESS then
          TabSize := Value;
        Size := 4;
        if RegQueryValueEx(EditorKey, 'Undo Limit', nil, nil, @Value, @Size) = ERROR_SUCCESS then
          UndoLimit := Value;
        Size := 4;
        if (RegQueryValueEx(EditorKey, 'Font Name', nil, nil, nil, @Size) = ERROR_SUCCESS) and
           (Size > 0) then
        begin
          GetMem(Buffer, Size);
          RegQueryValueEx(EditorKey, 'Font Name', nil, nil, Buffer, @Size);
          EditorFontName := PChar(Buffer);
          FreeMem(Buffer);
        end;
        Size := 4;
        if RegQueryValueEx(EditorKey, 'Font Size', nil, nil, @Value, @Size) = ERROR_SUCCESS then
          EditorFontSize := Value;
        Size := 4;
        if RegQueryValueEx(EditorKey, 'Mark Foreground', nil, nil, @Value, @Size) = ERROR_SUCCESS then
          EditorMarkForeground := Value;
        Size := 4;
        if RegQueryValueEx(EditorKey, 'Mark Background', nil, nil, @Value, @Size) = ERROR_SUCCESS then
          EditorMarkBackground := Value;
        Size := 4;
        if RegQueryValueEx(EditorKey, 'ScrollBar Mode', nil, nil, @Value, @Size) = ERROR_SUCCESS then
          if Value in [0..2] then ScrollBarMode := TScrollBarMode(Value)
                             else ScrollBarMode := sbmRegular;
      finally
        RegCloseKey(EditorKey);
      end;

    // load window settings
    Placement.length := SizeOf(Placement);
    Size := Placement.length;
    if RegQueryValueEx(Key, 'MainWindow', nil, @ValueType, @Placement, @Size) = ERROR_SUCCESS then
      SetWindowPlacement(Handle, @Placement);

    Size := 4;
    if RegQueryValueEx(Key, 'Toolbar Visibility', nil, @ValueType, @Value, @Size) = ERROR_SUCCESS then
    begin
      MenuToolBar.Visible := Value and (1 shl 0) <> 0;
      FileToolBar.Visible := Value and (1 shl 1) <> 0;
      EditToolBar.Visible := Value and (1 shl 2) <> 0;
      MiscToolBar.Visible := Value and (1 shl 3) <> 0;
      ShowMenu1.Checked := MenuToolBar.Visible;
      ShowFileToolBar1.Checked := FileToolBar.Visible;
      ShowEditToolBar1.Checked := EditToolBar.Visible;
      ShowControlToolBar1.Checked := MiscToolBar.Visible;
    end;
    Size := 4;
    if RegQueryValueEx(Key, 'MenuToolbar', nil, @ValueType, @Value, @Size) = ERROR_SUCCESS then
    begin
      MenuToolbar.Left := LoWord(Value);
      MenuToolbar.Top := HiWord(Value);
    end;
    Size := 4;
    if RegQueryValueEx(Key, 'FileToolbar', nil, @ValueType, @Value, @Size) = ERROR_SUCCESS then
    begin
      FileToolbar.Left := LoWord(Value);
      FileToolbar.Top := HiWord(Value);
    end;
    Size := 4;
    if RegQueryValueEx(Key, 'EditToolbar', nil, @ValueType, @Value, @Size) = ERROR_SUCCESS then
    begin
      EditToolbar.Left := LoWord(Value);
      EditToolbar.Top := HiWord(Value);
    end;
    Size := 4;
    if RegQueryValueEx(Key, 'MiscToolbar', nil, @ValueType, @Value, @Size) = ERROR_SUCCESS then
    begin
      MiscToolbar.Left := LoWord(Value);
      MiscToolbar.Top := HiWord(Value);
    end;

    // load other global settings
    with GlobalSettings do
    begin
      if (RegQueryValueEx(Key, 'DCCPath', nil, nil, nil, @Size) = ERROR_SUCCESS) and
         (Size > 0) then
      begin
        GetMem(Buffer, Size);
        RegQueryValueEx(Key, 'DCCPath', nil, nil, Buffer, @Size);
        DCC32Path := PChar(Buffer);
        FreeMem(Buffer);
      end;
      Size := 4;
      if RegQueryValueEx(Key, 'AutoSaveDesktop', nil, nil, @Value, @Size) = ERROR_SUCCESS then
        AutoSaveDesktop := Value <> 0;
      Size := 4;
      if RegQueryValueEx(Key, 'AutoSaveEditor', nil, nil, @Value, @Size) = ERROR_SUCCESS then
        AutoSaveEditor := Value <> 0;
      Size := 4;
      if RegQueryValueEx(Key, 'CreateBackups', nil, nil, @Value, @Size) = ERROR_SUCCESS then
        CreateBackups := Value <> 0;

      Size := 4;
      if RegQueryValueEx(Key, 'MultilinePageControl', nil, nil, @Value, @Size) = ERROR_SUCCESS then
        MultilinePageControl := Value <> 0;
      Size := 4;
      if RegQueryValueEx(Key, 'ShowFileIcons', nil, nil, @Value, @Size) = ERROR_SUCCESS then
        ShowFileIcons := Value <> 0;
      Size := 4;
      if RegQueryValueEx(Key, 'MinimizeToTray', nil, nil, @Value, @Size) = ERROR_SUCCESS then
        MinimizeToTray := Value <> 0;

      UpdateShortCuts;
    end;

    // read MRU list
    ReadPreferenceStrings(Key, 'MRU projects', FLastProjects);
    // limit to last 10 entries
    while FLastProjects.Count > 10 do FLastProjects.Delete(FLastProjects.Count - 1);

    // reopen last opened projects if there were no command line parameters
    if ParamCount = 0 then
    begin
      List := TStringList.Create;
      ReadPreferenceStrings(Key, 'Open Projects', List);
      // limit to last 10 entries
      while List.Count > 10 do List.Delete(List.Count - 1);

      AddProjectFiles(List);
      List.Free;
    end;
  finally
    RegCloseKey(Key);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.WritePreferences;

var
  List: TStringList;
  I: Integer;
  Key,
  EditorKey: HKEY;
  Disposition: Integer;
  Placement: TWindowPlacement;
  Value: DWORD;

begin
  // if the user has choosen to remove all registry entries then this flag is set
  if GlobalSettings.DontWriteSettings then Exit;
  
  if RegCreateKeyEx(HKEY_CURRENT_USER, 'Software\Delphi Compiler Generator', 0, nil,
                    REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, nil, Key, @Disposition) = ERROR_SUCCESS then
  try
    // write MRU list
    WritePreferenceStrings(Key, 'MRU Projects', FLastProjects);

    List := TStringList.Create;
    for I := 0 to Projects.Count - 1 do
      if not TBaseProjectForm(Projects[I]).NewProject then  List.Add(TBaseProjectForm(Projects[I]).WorkingFile);
    // write list of all currently opened projects
    WritePreferenceStrings(Key, 'Open Projects', List);
    List.Free;

    // write window settings
    Placement.length := SizeOf(Placement);
    GetWindowPlacement(Handle, @Placement);
    RegSetValueEx(Key, 'MainWindow', 0, REG_BINARY, @Placement, SizeOf(Placement));
    Value := MakeLParam(MenuToolbar.Left, MenuToolbar.Top);
    RegSetValueEx(Key, 'MenuToolbar', 0, REG_DWORD, @Value, 4);
    Value := MakeLParam(FileToolbar.Left, FileToolbar.Top);
    RegSetValueEx(Key, 'FileToolbar', 0, REG_DWORD, @Value, 4);
    Value := MakeLParam(EditToolbar.Left, EditToolbar.Top);
    RegSetValueEx(Key, 'EditToolbar', 0, REG_DWORD, @Value, 4);
    Value := MakeLParam(MiscToolbar.Left, MiscToolbar.Top);
    RegSetValueEx(Key, 'MiscToolbar', 0, REG_DWORD, @Value, 4);
    Value := Ord(MenuToolBar.Visible) shl 0 or
             Ord(FileToolBar.Visible) shl 1 or
             Ord(EditToolBar.Visible) shl 2 or
             Ord(MiscToolBar.Visible) shl 3;
    RegSetValueEx(Key, 'Toolbar Visibility', 0, REG_DWORD, @Value, 4);

    // write other global settings
    with GlobalSettings do
    begin
      RegSetValueEx(Key, 'DCCPath', 0, REG_SZ, PChar(DCC32Path), Length(DCC32Path));
      Value := Ord(AutoSaveEditor);
      RegSetValueEx(Key, 'AutoSaveEditor', 0, REG_DWORD, @Value, 4);
      Value := Ord(AutoSaveDesktop);
      RegSetValueEx(Key, 'AutoSaveDesktop', 0, REG_DWORD, @Value, 4);
      Value := Ord(CreateBackups);
      RegSetValueEx(Key, 'CreateBackups', 0, REG_DWORD, @Value, 4);
      Value := Ord(MultilinePageControl);
      RegSetValueEx(Key, 'MultilinePageControl', 0, REG_DWORD, @Value, 4);
      Value := Ord(ShowFileIcons);
      RegSetValueEx(Key, 'ShowFileIcons', 0, REG_DWORD, @Value, 4);
      Value := Ord(MinimizeToTray);
      RegSetValueEx(Key, 'MinimizeToTray', 0, REG_DWORD, @Value, 4);
    end;

    // write editor settings
    if RegCreateKeyEx(Key, 'Editor', 0, nil, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
                      nil, EditorKey, @Disposition) = ERROR_SUCCESS then
    begin
      SaveKeystrokesToRegistry(EditorKey, GlobalSettings.EditorCommands);
      SaveHighlightersToRegistry(EditorKey);
      with GlobalSettings do
      begin
        RegSetValueEx(EditorKey, 'Edit Options', 0, REG_BINARY, @EditOptions, SizeOf(EditOptions));
        RegSetValueEx(EditorKey, 'Block Indent', 0, REG_DWORD, @BlockIndent, 4);
        RegSetValueEx(EditorKey, 'Tab Size', 0, REG_DWORD, @TabSize, 4);
        RegSetValueEx(EditorKey, 'Undo Limit', 0, REG_DWORD, @UndoLimit, 4);
        RegSetValueEx(EditorKey, 'Font Name', 0, REG_SZ, PChar(EditorFontName), Length(EditorFontName));
        RegSetValueEx(EditorKey, 'Font Size', 0, REG_DWORD, @EditorFontSize, 4);
        RegSetValueEx(EditorKey, 'Mark Foreground', 0, REG_DWORD, @EditorMarkForeground, 4);
        RegSetValueEx(EditorKey, 'Mark Background', 0, REG_DWORD, @EditorMarkBackground, 4);
        RegSetValueEx(EditorKey, 'ScrollBar Mode', 0, REG_DWORD, @ScrollbarMode, 4);
      end;
      RegCloseKey(EditorKey);
    end;
  finally
    RegCloseKey(Key);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditSelectAllActionExecute(Sender: TObject);

begin
  TProjectForm(FActiveProject).CurrentEdit.SelectAll;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditPasteActionExecute(Sender: TObject);

begin
  TProjectForm(FActiveProject).CurrentEdit.PasteFromClipboard;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditCutActionExecute(Sender: TObject);

begin
  TProjectForm(FActiveProject).CurrentEdit.CutToClipboard;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditCopyActionExecute(Sender: TObject);

begin
  TProjectForm(FActiveProject).CurrentEdit.CopyToClipboard;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SaveAsActionExecute(Sender: TObject);

begin
  if assigned(FActiveProject) then FActiveProject.SaveAs;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.GenerateActionExecute(Sender: TObject);

begin
  if assigned(FActiveProject) then FActiveProject.Execute;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.PropertiesActionExecute(Sender: TObject);

begin
  if ShowProjectOptions(FActiveProject) then
    with FActiveProject as TProjectForm do
    begin
      ProjectChange(nil);
      ValidateControls;
    end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditUndoActionExecute(Sender: TObject);

begin
  TProjectForm(FActiveProject).CurrentEdit.Undo;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditRedoActionExecute(Sender: TObject);

begin
  TProjectForm(FActiveProject).CurrentEdit.Redo;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.UpdateActions;

// updates enabled state of all globally available actions

var
  ProjectAvailable,
  EditAvailable: Boolean;

begin
  inherited;
  ProjectAvailable := Assigned(FActiveProject);
  EditAvailable := ProjectAvailable and Assigned(TProjectForm(FActiveProject).CurrentEdit);

  // file actions
  SaveAsAction.Enabled := EditAvailable;
  SaveProjectAsAction.Enabled := ProjectAvailable;
  SaveAllAction.Enabled := ProjectAvailable and TProjectForm(FActiveProject).NeedSave;
  CloseAction.Enabled := ProjectAvailable;

  // edit actions
  EditUndoAction.Enabled := EditAvailable and TProjectForm(FActiveProject).CurrentEdit.CanUndo;
  EditRedoAction.Enabled := EditAvailable and TProjectForm(FActiveProject).CurrentEdit.CanRedo;
  EditPasteAction.Enabled := EditAvailable and Clipboard.HasFormat(CF_TEXT);
  EditCopyAction.Enabled := EditAvailable and TProjectForm(FActiveProject).CurrentEdit.SelAvail;
  EditCutAction.Enabled := EditCopyAction.enabled;
  EditSelectAllAction.Enabled := EditAvailable;

  // project actions
  GenerateAction.Enabled := ProjectAvailable and FActiveProject.visible;
  PropertiesAction.Enabled := ProjectAvailable;
  EditControlCharAction.Enabled := EditAvailable;
  if EditControlCharAction.Enabled then
  begin
    ControlCharButton.Down := TProjectForm(FActiveProject).ShowControlChars;
    EditControlCharAction.Checked := ControlcharButton.Down;
  end;

  // window actions
  WindowListButton.Down := WindowListAction.checked;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditControlCharActionExecute(Sender: TObject);

begin
  TProjectForm(FActiveProject).ShowControlChars := not EditControlCharAction.Checked;
  FActiveProject.SetFocus;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SaveAllActionExecute(Sender: TObject);

// do save all open files of all open project

var
  I: Integer;

begin
  for I := 0 to Projects.Count - 1 do
  begin
    if not TBaseProjectForm(Projects[I]).SaveAll then Break;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EnvironmentItemClick(Sender: TObject);

begin
  ShowEnvironmentSettings(False);
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.UpdateShortCuts;

// adjust display for short cuts in menus

var
  Index: Integer;

begin
  with GlobalSettings.EditorCommands do
  begin
    Index := FindCommand(ecCopy);
    if Index > -1 then EditCopyAction.ShortCut := Items[Index].ShortCut
                  else EditCopyAction.ShortCut := 0;
    Index := FindCommand(ecCut);
    if Index > -1 then EditCutAction.ShortCut := Items[Index].ShortCut
                  else EditCutAction.ShortCut := 0;
    Index := FindCommand(ecPaste);
    if Index > -1 then EditPasteAction.ShortCut := Items[Index].ShortCut
                  else EditPasteAction.ShortCut := 0;
    Index := FindCommand(ecSelectAll);
    if Index > -1 then EditSelectAllAction.ShortCut := Items[Index].ShortCut
                  else EditSelectAllAction.ShortCut := 0;
    Index := FindCommand(ecUndo);
    if Index > -1 then EditUndoAction.ShortCut := Items[Index].ShortCut
                  else EditUndoAction.ShortCut := 0;
    Index := FindCommand(ecRedo);
    if Index > -1 then EditRedoAction.ShortCut := Items[Index].ShortCut
                  else EditRedoAction.ShortCut := 0;
    Index := FindCommand(ecDelete);
    if Index > -1 then EditDeleteAction.ShortCut := Items[Index].ShortCut
                  else EditDeleteAction.ShortCut := 0;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ShowEnvironmentSettings(EditorOnly: Boolean);

begin
  EnvironmentOptionsDialog.EditorSettingsOnly := EditorOnly;
  if EnvironmentOptionsDialog.ShowModal = mrOK then
  begin
    UpdateShortCuts;
    NotifyProjects;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.NotifyProjects;

var
  I: Integer;

begin
  // notify editors about changes
  for I := 0 to Projects.Count - 1 do
    TProjectForm(Projects[I]).ApplyGlobalSettings;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.CheckProjectFiles(Sender: TObject);

var
  I: Integer;

begin
  // let each loaded project check the time stamp of their loaded files and ask the user
  // to reload any which has been changed
  for I := 0 to Projects.Count - 1 do
    TBaseProjectForm(Projects[I]).CheckFileAges;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ToolbarMenuItemClick(Sender: TObject);

begin
  case (Sender as TMenuItem).Tag of
    0:
      begin
        ShowMenu1.Checked := not ShowMenu1.Checked;
        MenuToolBar.Visible := ShowMenu1.Checked;
      end;
    1:
      begin
        ShowFileToolBar1.Checked := not ShowFileToolBar1.Checked;
        FileToolBar.Visible := ShowFileToolBar1.Checked;
      end;
    2:
      begin
        ShowEditToolBar1.Checked := not ShowEditToolBar1.Checked;
        EditToolBar.Visible := ShowEditToolBar1.Checked;
      end;
    3:
      begin
        ShowControlToolBar1.Checked := not ShowControlToolBar1.Checked;
        MiscToolBar.Visible := ShowControlToolBar1.Checked;
      end;
  end;
end;                                   

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditFindReplaceActionExecute(Sender: TObject);

var
  Result: TModalResult;
  CurrentWord: WideString;
  BB, BE: TPoint;

begin
  if Assigned(FActiveProject) and Assigned(TProjectForm(FActiveProject).CurrentEdit) then
  begin
    with TProjectForm(FActiveProject).CurrentEdit, SyntaxFindDialog do
    begin
      if (Sender as TAction).Tag = 0 then SearchRadioButton.Checked := True;
      if (Sender as TAction).Tag = 1 then ReplaceRadioButton.Checked := True;
      SelectedRadioButton.Checked := SelAvail;
      if not SelAvail then
      begin
        GlobalRadioButton.Checked := True;
        CurrentWord := GetWordAndBounds(CaretXY, BB, BE);
        if (BB.X <= CaretX) and (CaretX <= BE.X) then
          if CurrentWord <> '' then FindTextComboBox.Text := CurrentWord;
          // otherwise use last text
      end
      else FindTextComboBox.Text := SelText;
      Result:= ShowModal;
      if Result <> mrCancel then
      begin
        FLastSearchOptions := [];
        if CaseCheckBox.Checked then Include(FLastSearchOptions, soMatchCase);
        if WholeWordCheckBox.Checked then Include(FLastSearchOptions, soWholeWord);
        if BackwardRadioButton.Checked then Include(FLastSearchOptions, soBackwards);
        if HomeRadioButton.Checked then Include(FLastSearchOptions, soEntireScope);
        if SelectedRadioButton.Checked then Include(FLastSearchOptions, soSelectedOnly);
        if NonSpacingCheckBox.Checked then Include(FLastSearchOptions, soIgnoreNonSpacing);
        if CompressCheckBox.Checked then Include(FLastSearchOptions, soSpaceCompress);
        if RECheckBox.Checked then Include(FLastSearchOptions, soRegularExpression);
        if PromptCheckBox.Checked then Include(FLastSearchOptions, soPrompt);
        if ReplaceRadioButton.Checked then
        begin
          Include(FLastSearchOptions, soReplace);
          if Result = mrYesToAll then Include(FlastSearchOptions, soReplaceAll);
        end;

        if SelAvail and SelectedRadioButton.Checked then Include(FLastSearchOptions, soSelectedOnly);
        if SearchReplace(FindTextComboBox.Text, NewTextComboBox.Text, FLastSearchOptions) = 0 then
          MessageDlg('No further occurence of ''' + FindTextComboBox.Text + ''' found.',
                     mtInformation, [mbOK], 0);
      end;
    end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EditFindAgainActionExecute(Sender: TObject);

begin
  if Assigned(FActiveProject) and Assigned(TProjectForm(FActiveProject).CurrentEdit) then
  begin
    with SyntaxFindDialog do
    begin
      if FindTextComboBox.Text = '' then EditFindAction.Execute
                                    else
      begin
        // use the same options as before but start at current cursor position
        with TProjectForm(FActiveProject).CurrentEdit do
          if SearchReplace(FindTextComboBox.Text, NewTextComboBox.Text,
            FLastSearchOptions - [soEntireScope, soSelectedOnly]) = 0 then
              MessageDlg('No further occurence of ''' + FindTextComboBox.Text + ''' found.', mtInformation, [mbOK], 0);
      end;
    end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

end.














 
