unit MessageWindow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DockForm;

type
  TMessageForm = class(TDockableForm)
    MessageList: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure MessageListDblClick(Sender: TObject);
  private
    FFirstShow: Boolean;
  protected
    procedure VisibleChanging; override;
  public
    property FirstShow: Boolean read FFirstShow;
  end;

var
  MessageForm: TMessageForm;

//----------------------------------------------------------------------------------------------------------------------

implementation

uses
  DCGTools, Project;

{$R *.DFM}

//----------------------------------------------------------------------------------------------------------------------

procedure TMessageForm.FormCreate(Sender: TObject);

begin
  FFirstShow := True;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMessageForm.VisibleChanging;

begin
  inherited;
  FFirstShow := False;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMessageForm.MessageListDblClick(Sender: TObject);

var
  MI: PMessageInfo;

begin
  MI := Pointer(MessageList.Items.Objects[MessageList.ItemIndex]);
  TProjectForm(Owner).ShowMarkedEdit(MI);
end;

//----------------------------------------------------------------------------------------------------------------------

end.

